#pragma once

#include "DataContext.h"
#include <vector>
#include <algorithm>

interface IXMLValueConverter
{
public:
	~IXMLValueConverter() {}

	virtual CComVariant MakeVariant(LPCTSTR data) = 0;	
};
interface IXMLValueValidater
{
public:
	~IXMLValueValidater() {}

	virtual BOOL IsValid(LPCTSTR key, LPCTSTR data) = 0;
	virtual void Fix(LPCTSTR key, LPCTSTR data, LPTSTR newData, int len) = 0;
};
class NPCOMMONUI_API XMLDataProvider
{
public:
	XMLDataProvider(IDataContext* datacontext);
	virtual ~XMLDataProvider();
	
	void Load(TiXmlElement* element);
	void SetValidater(IXMLValueValidater* validater) { m_valueValidater = validater; }

	//void SetData(LPCTSTR key, CComVariant data);
	//CComVariant GetData(LPCTSTR key);
	IDataContext* CreateDataContext() { return new SimpleMapDataContext; }

protected:
	void LoadAttribute(TiXmlElement* element);
	void LoadElement(TiXmlElement* element);
	CComVariant LoadChildElement(TiXmlElement* childElement);
	BOOL IsOneElement(TiXmlElement* element);

	BOOL GetChildValue(TiXmlNode* pChildNode, TCHAR* pszValue, INT nMax);
	BOOL GetValue(TiXmlElement* pValueNode, TCHAR* pszValue, INT nMax);

private:
	IDataContext* m_datacontext;
	IXMLValueConverter* m_valueConverter;
	IXMLValueValidater* m_valueValidater;
};